Loading...
Searching...
No Matches
cl::Pipe Class Reference

Class interface for Pipe Memory Objects. More...

`#include <opencl.hpp>`

Inheritance diagram for cl::Pipe:

## Public Member Functions

| Pipe (const Context &context, cl_uint packet_size, cl_uint max_packets, cl_int *err=nullptr)
| Constructs a Pipe in a specified context.
| Pipe (cl_uint packet_size, cl_uint max_packets, cl_int *err=nullptr)
| Constructs a Pipe in a the default context.
| Pipe ()
| Default constructor - initializes to nullptr.
| Pipe (const cl_mem &pipe, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Pipe & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy.
template<typename T>
cl_int | getInfo (cl_pipe_info name, T *param) const
| Wrapper for clGetMemObjectInfo().
template<cl_pipe_info name>
detail::param_traits< detail::cl_pipe_info, name >::param_type | getInfo (cl_int *err=nullptr) const
| Wrapper for clGetMemObjectInfo() that returns by value.
Public Member Functions inherited from cl::Memory
| Memory ()
| Default constructor - initializes to nullptr.
| Memory (const cl_mem &memory, bool retainObject)
| Constructor from cl_mem - takes ownership.
Memory & | operator= (const cl_mem &rhs)
| Assignment operator from cl_mem - takes ownership.
template<typename T>
cl_int | getInfo (cl_mem_info name, T *param) const
| Wrapper for clGetMemObjectInfo().
template<cl_mem_info name>
detail::param_traits< detail::cl_mem_info, name >::param_type | getInfo (cl_int *err=nullptr) const
| Wrapper for clGetMemObjectInfo() that returns by value.
cl_int | setDestructorCallback (void(CL_CALLBACK *pfn_notify)(cl_mem, void *), void *user_data=nullptr)
| Registers a callback function to be called when the memory object is no longer needed.
Public Member Functions inherited from cl::detail::Wrapper< cl_mem >
Wrapper< cl_type > & | operator= (const Wrapper< cl_type > &rhs)
const cl_type & | operator() () const
cl_type | get () const

## Additional Inherited Members

Public Types inherited from cl::detail::Wrapper< cl_mem >
typedef cl_mem | cl_type
Protected Member Functions inherited from cl::detail::Wrapper< cl_mem >
cl_int | retain () const
cl_int | release () const
Protected Attributes inherited from cl::detail::Wrapper< cl_mem >
cl_type | object_

## Detailed Description

Class interface for Pipe Memory Objects.

See Memory for details about copy semantics, etc.

See also
  Memory

Definition at line 5894 of file opencl.hpp.

## Constructor & Destructor Documentation

## Pipe() [1/4]

cl::Pipe::Pipe | ( | const Context & | context,
|  | cl_uint | packet_size,
|  | cl_uint | max_packets,
|  | cl_int * | err = nullptr )

inline

Constructs a Pipe in a specified context.

Wraps clCreatePipe().

Parameters

  context | Context in which to create the pipe.
  flags | Bitfield. Only CL_MEM_READ_WRITE and CL_MEM_HOST_NO_ACCESS are valid.
  packet_size | Size in bytes of a single packet of the pipe.
  max_packets | Number of packets that may be stored in the pipe.

Definition at line 5907 of file opencl.hpp.

## Pipe() [2/4]

cl::Pipe::Pipe | ( | cl_uint | packet_size,
|  | cl_uint | max_packets,
|  | cl_int * | err = nullptr )

inline

Constructs a Pipe in a the default context.

Wraps clCreatePipe().

Parameters

  flags | Bitfield. Only CL_MEM_READ_WRITE and CL_MEM_HOST_NO_ACCESS are valid.
  packet_size | Size in bytes of a single packet of the pipe.
  max_packets | Number of packets that may be stored in the pipe.

Definition at line 5932 of file opencl.hpp.

## Pipe() [3/4]

cl::Pipe::Pipe | ( |  | ) |

inline

Default constructor - initializes to nullptr.

Definition at line 5951 of file opencl.hpp.

## Pipe() [4/4]

cl::Pipe::Pipe | ( | const cl_mem & | pipe,
|  | bool | retainObject = false )

inline explicit

Constructor from cl_mem - takes ownership.

Parameters

  retainObject | will cause the constructor to retain its cl object. Defaults to false to maintain compatibility with earlier versions.

See Memory for further details.

Definition at line 5960 of file opencl.hpp.

## Member Function Documentation

## getInfo() [1/2]

template<cl_pipe_info name>

detail::param_traits< detail::cl_pipe_info, name >::param_type cl::Pipe::getInfo | ( | cl_int * | err = nullptr | ) | const

inline

Wrapper for clGetMemObjectInfo() that returns by value.

Definition at line 5987 of file opencl.hpp.

## getInfo() [2/2]

template<typename T>

cl_int cl::Pipe::getInfo | ( | cl_pipe_info | name,
|  | T * | param ) const

inline

Wrapper for clGetMemObjectInfo().

Definition at line 5977 of file opencl.hpp.

## operator=()

Pipe & cl::Pipe::operator= | ( | const cl_mem & | rhs | ) |

inline

Assignment from cl_mem - performs shallow copy.

See Memory for further details.

Definition at line 5967 of file opencl.hpp.

The documentation for this class was generated from the following file:

- opencl.hpp